﻿using UnityEngine;
using System.Collections;

public class LightFlickerer : MonoBehaviour {

	private float defaultIntensity;

	public float maxOnTime, maxOffTime, maxSwitchingOnTime, maxSwitchingOffTime, brightnessLowerBoundMulti, brightnessUpperBoundMulti;

	private Light flickeree;

	private float nextOffTime, nextOffDuration, nextOnTime, nextOnDuration, nextOnIntensity, minIntensity, maxIntensity;

	private bool turningOff, turningOn, turnedOff, turnedOn;

	// Use this for initialization
	void Start () {
		flickeree = this.GetComponent<Light>();
		if(flickeree == null) print("LightFlickerer on " + this.name + " expected a Light but didn't find one!");
		defaultIntensity = flickeree.intensity;
		minIntensity = defaultIntensity * brightnessLowerBoundMulti;
		maxIntensity = defaultIntensity * brightnessUpperBoundMulti;

		nextOffTime = Time.time + (Random.value * maxOnTime);

		nextOnIntensity = defaultIntensity;

		turnedOff = false;
		turnedOn = true;
		turningOff = false;
		turningOff = false;
		//print (nextOffTime);
	}
	
	// Update is called once per frame
	void Update () {
		if(turningOff){
			flickeree.intensity = Mathf.Lerp(nextOnIntensity, 0, (Time.time - nextOffTime) / nextOffDuration);
			if(Time.time >= nextOffTime + nextOffDuration){
				turningOff = false;
				turnedOff = true;
			}
			return;
		} else if(turningOn){
			flickeree.intensity = Mathf.Lerp(0, nextOnIntensity, (Time.time - nextOnTime) / nextOnDuration);
			if(Time.time >= nextOnTime + nextOnDuration){
				turningOn = false;
				turnedOn = true;
			}
			return;
		}
		if (Time.time >= nextOffTime && turnedOn) turnOff();
		if (Time.time >= nextOnTime && turnedOff) turnOn();
		//print (Time.time);
	}

	void turnOff(){
		turningOff = true;
		turnedOn = false;
		nextOffDuration = Random.value * maxSwitchingOffTime;
		nextOnTime = Time.time + nextOffDuration + (Random.value * maxOffTime);
		//print("turn off");
	}

	void turnOn(){
		turningOn = true;
		turnedOff = false;
		nextOnDuration = Random.value * maxSwitchingOnTime;
		nextOffTime = Time.time + nextOnDuration + (Random.value * maxOnTime);
		nextOnIntensity = Random.Range(minIntensity, maxIntensity);
	}
}
