﻿using UnityEngine;
using System.Collections;

public class StandardArmamentTraining : MonoBehaviour {

	public Transform targetingSystem;
	
	public Transform bulletOrigin;
	
	public Transform bullet;

	public Transform bulletParent;

	private TargetManager targets;

	public float reloadTime = .5F;

	private float lastFireTime;

	public Transform shootSound;

	// Use this for initialization
	void Start () {
		targets = targetingSystem.GetComponent<TargetManager>();
		if (targets == null) print (this.name + " expected a TargetManager on " + targetingSystem.name + " but couldn't find one!");
		lastFireTime = Time.time - reloadTime;

		bulletParent = GameObject.Find("BulletParent").transform;
		if(bulletParent == null) print (this.name + " couldn't find an object called BulletParent");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	public void fire(){
		if(lastFireTime + reloadTime > Time.time) return;
		Transform newBullet = (Transform) Instantiate(bullet, bulletOrigin.position, bulletOrigin.rotation);
		BulletScript newbs = newBullet.GetComponent<BulletScript>();
		if(newbs != null){ //what the hell didn't happen here?
			//Physics.IgnoreCollision(this.transform.collider, newBullet.collider);
			
			if(targets.getNumTargets() > 0){
				Vector3 targetPos = targets.getNarrowestAngleTarget().position;
				newbs.pointMe(new Vector3(targetPos.x, bulletOrigin.position.y, targetPos.z));
				//print ("fired with target");
			} else {
				//newbs.targetPos = bulletOrigin.TransformPoint(0,0,10);
				newbs.pointMe(bulletOrigin.TransformPoint(0,0,10));
			}
			newbs.friend = this.gameObject;
		}
		newBullet.parent = bulletParent;
		lastFireTime = Time.time;
		if(shootSound != null){
			Instantiate(shootSound, bulletOrigin.position, bulletOrigin.rotation);
		}
	}

	public void removeTarget(Transform target){
		targets.removeTarget(target);
	}

	public int numTargetsInRange(){
		return targets.getNumTargets();
	}
}
