﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class TargetManager : MonoBehaviour {

	private List<Transform> targets;

	public string targetClass;

	// Use this for initialization
	void Start () {
		targets = new List<Transform>();
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnTriggerEnter(Collider other){
		if(other.gameObject.GetComponent(targetClass) != null){
			if(!targets.Contains(other.transform)){
				//print("got target");
				targets.Add(other.transform);
				//if(other.GetComponent(typeof(IShootable)) != null) print("is shootable");
			}
		}
	}

	void OnTriggerExit(Collider other){
		if(other.gameObject.GetComponent(targetClass) != null){
			if(targets.Contains(other.transform)){
				//print("lost target");
				targets.Remove(other.transform);
			}
		}
	}

	public Transform getNarrowestAngleTarget(){
		if(targets.Count == 0){
			return null;
		} else if(targets.Count == 1){
			return targets[0];
		} else {
			Transform narrowest = null;
			float narrowestAngle = 180;
			foreach(Transform t in targets){
				if(t == null){
					targets.Remove(t); //why the hell is it in there - and why the hell am i checking?
				} else {
					float tAngle = Vector3.Angle(this.transform.position, t.position);
					if(tAngle < narrowestAngle){
						narrowestAngle = tAngle;
						narrowest = t;
					}
				}
			}
			return narrowest;
		}
	}

	public int getNumTargets(){
		return targets.Count;
	}

	public void removeTarget(Transform target){
		targets.Remove(target);
	}
}
